package naknak;

import java.io.File;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import naknak.eingabe.EingabeListener;
import naknak.eingabe.EingabeVerwaltung;
import naknak.programm.Welt;
import net.java.games.jogl.Animator;
import net.java.games.jogl.GLCanvas;
import net.java.games.jogl.GLCapabilities;
import net.java.games.jogl.GLDrawableFactory;

/**
 * NakNak-Programm
 * OpenGL mit Java SS 2006
 * 
 * @author Michael Erlmann
 *
 */
public class NakNak {
	public static void main(String[] args) {
		String level = promptScreenMode();
		JFrame frame = new JFrame("NakNak");
		EingabeVerwaltung eingabe = new EingabeVerwaltung();
		EingabeListener listener = new EingabeListener(eingabe);
		
		// Canvas ( -> "Zeichenflche") erstellen
		GLCanvas canvas = 
			GLDrawableFactory.getFactory()
			    .createGLCanvas(new GLCapabilities());
		
		// canvas in den Vordergrund holen
		canvas.requestFocus();

		// GLEventListener anmelden
		canvas.addGLEventListener(new NakNakGLEventListener(frame, eingabe, new Welt(), level));

		// Animator anmelden
		Animator animator = new Animator(canvas);

		// Fenster erstellen und Canvas hinzufgen
		frame.setSize(800,600);
		frame.add(canvas);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		// Tastatur- und Mausabfrage
		canvas.addKeyListener(listener);
		canvas.addMouseListener(listener);
		canvas.addMouseMotionListener(listener);
		canvas.addMouseWheelListener(listener);
		
		// Fenster anzeigen und Animator starten
		frame.setVisible(true);
		animator.start();
	}
	
	
	/**
	 * Wahl des Levels
	 * 
	 * @return Dateiname des gewaehlten Levels
	 */
	private static String promptScreenMode() {
		String message = "Waehle dein Level:";
		String[] entries = new File("."+File.separator+"naknak"+File.separator+"levels"+File.separator+"").list();
		int option =
			JOptionPane.showOptionDialog(
					null,
					message,
					"NakNak die kleine Ente",
					JOptionPane.DEFAULT_OPTION,
					JOptionPane.QUESTION_MESSAGE,
					null,
					entries,
					null);
		if(option==-1) System.exit(-1);
		return entries[option];
	}


}