package naknak.eingabe;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

/**
 * Verwendete Eingabelistener fuer Tastatur und Maus
 * 
 * @author Michael Erlmann
 */
public class EingabeListener implements KeyListener, MouseListener, MouseMotionListener, MouseWheelListener {
	EingabeVerwaltung eingabe;

	public EingabeListener(EingabeVerwaltung eingabe){
		this.eingabe = eingabe;
	}

	public void keyPressed(KeyEvent arg0) {
		if(arg0.getKeyCode()==67) eingabe.setDraufsicht(!eingabe.isDraufsicht()); // c
		if(arg0.getKeyCode()==87) eingabe.setBewegungVor(true); // w
		if(arg0.getKeyCode()==65) eingabe.setDrehungLinks(true); // a
		if(arg0.getKeyCode()==83) eingabe.setBewegungZurueck(true); // s
		if(arg0.getKeyCode()==68) eingabe.setDrehungRechts(true); // d
		if(arg0.getKeyCode()==32) eingabe.setCell(!eingabe.isCell()); // leertaste		
	}

	public void keyReleased(KeyEvent arg0) {
		if(arg0.getKeyCode()==87) eingabe.setBewegungVor(false); // w
		if(arg0.getKeyCode()==65) eingabe.setDrehungLinks(false); // a
		if(arg0.getKeyCode()==83) eingabe.setBewegungZurueck(false); // s
		if(arg0.getKeyCode()==68) eingabe.setDrehungRechts(false); // d
	}

	public void mousePressed(MouseEvent arg0) {
		if(arg0.getButton()==3)eingabe.setDrehungAktiv(true);
	}

	public void mouseReleased(MouseEvent arg0) {
		if(arg0.getButton()==3)eingabe.setDrehungAktiv(false);
	}

	public void mouseDragged(MouseEvent arg0) {
		eingabe.setXMausDelta(eingabe.getXMaus()-arg0.getX());
		eingabe.setYMausDelta(eingabe.getYMaus()-arg0.getY());
		eingabe.setXMaus(arg0.getX());
		eingabe.setYMaus(arg0.getY());
	}

	public void mouseMoved(MouseEvent arg0) {
		eingabe.setXMausDelta(eingabe.getXMaus()-arg0.getX());
		eingabe.setYMausDelta(eingabe.getYMaus()-arg0.getY());
		eingabe.setXMaus(arg0.getX());
		eingabe.setYMaus(arg0.getY());
	}
	
	public void mouseWheelMoved(MouseWheelEvent arg0) {
		eingabe.setZoom(arg0.getWheelRotation()*5);
	}
	
	// unbenutzt
	public void mouseExited(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {}
	public void keyTyped(KeyEvent arg0) {}
}
