package naknak.kamera;

import naknak.eingabe.EingabeVerwaltung;

/**
 * Kontrolle der Kamera
 * 
 * @author Michael Erlmann
 *
 */
public class KameraHandler {
	KameraTR kameraTR;
	Kamera2D kamera2D;
	EingabeVerwaltung eingabe;
	boolean isGeaendert = true;
	boolean isTR = true;
	
	/**
	 * Erstellt einen KameraHandler
	 * 
	 * @param kamera3D Kamera fuer 3D-Ansicht
	 * @param eingabe Zu verwendende EingabeVerwaltung
	 */
	public KameraHandler(KameraTR kameraTR, Kamera2D kamera2D, EingabeVerwaltung eingabe) {
		this.kameraTR = kameraTR;
		this.kamera2D = kamera2D;
		this.eingabe = eingabe;
	}
	
	/**
	 * Modifiziert die Kamera anhand der werte in der EingabeVerwaltung
	 * 
	 * @param zeitDiffSek Zeitabhaengige Veraenderung
	 */
	public void aktualisiereKamera(float zeitDiffSek) {
		if(eingabe.isDraufsicht()) { // 2D-Kamera Karte
			if(isTR) {
				isTR = false;
				isGeaendert = true;
			}

			// zoom
			if(eingabe.getZoom()!=0) {
				kamera2D.setZoomFaktor(kamera2D.getZoomFaktor() + eingabe.getZoom()*0.25f);
				isGeaendert = true;
				eingabe.setZoom(0);
			}
			
			// falls rechte maus gedrueckt bewegung der kamera seitlich (kamera verfolgt ente)
		/*	if(eingabe.isDrehungAktiv()){
				if(eingabe.getXMaus()!=eingabe.getXMausVor()) kamera2D.bewegeX(zeitDiffSek*0.2f*eingabe.getXMausDelta());
				if(eingabe.getYMaus()!=eingabe.getYMausVor()) kamera2D.bewegeZ(zeitDiffSek*0.2f*eingabe.getYMausDelta());
				eingabe.setXMausVor(eingabe.getXMaus());
				eingabe.setYMausVor(eingabe.getYMaus());
			}*/
		} else { // TombRaider-Cam
			if(!isTR) {
				isTR = true;
				isGeaendert = true;
			}
			// falls rechte maus gedrueckt drehung der kamera um die ente
			if(eingabe.isDrehungAktiv()){
				if(eingabe.getXMaus()!=eingabe.getXMausVor()) kameraTR.rotiereUmY(zeitDiffSek*200*eingabe.getXMausDelta());
				if(eingabe.getYMaus()!=eingabe.getYMausVor()) kameraTR.rotiereUmX(zeitDiffSek*200*eingabe.getYMausDelta());
				eingabe.setXMausVor(eingabe.getXMaus());
				eingabe.setYMausVor(eingabe.getYMaus());
			}
			
			// bewegung der kamera per tastatur (nichtmehr, da nurnoch bewegung der ente)
		/*	if(eingabe.isBewegungVor()){
				kameraTR.bewegeZ(-zeitDiffSek*4);
			}
			if(eingabe.isBewegungZurueck()){
				kameraTR.bewegeZ(+zeitDiffSek*4);
			}
			if(eingabe.isBewegungLinks()){
				kameraTR.bewegeX(-zeitDiffSek*4);
			}
			if(eingabe.isBewegungRechts()){
				kameraTR.bewegeX(+zeitDiffSek*4);
			} */
		}
	}

	public boolean isGeaendert() {
		return isGeaendert;
	}

	public void setGeaendert(boolean isGeaendert) {
		this.isGeaendert = isGeaendert;
	}

}
