package naknak.kollision;

import java.util.HashMap;

/**
 * Enthaelt die Geraden zur Kollisionsbestimmung
 * 
 * @author Michael Erlmann
 * 
 */
public class Raum {
	public HashMap<Integer, Wand> waende;

	public Raum(){
		waende = new HashMap<Integer, Wand>();
	}
	
	public void addWand(Wand wand) {
		waende.put(waende.size(),wand);
	}
	
	public boolean testeAufKollisionKreisWand(float mpx, float mpz, float radius, float winkelY, int wandnummer) {
		for(int i=wandnummer;i<waende.size();i++) {
			Wand wand = waende.get(i);
			float kollisionswert = -1;
			float PminusMx = wand.startx - mpx;
			float PminusMz = wand.startz - mpz;
			float UmalPmM = (wand.laengex*PminusMx)+(wand.laengez*PminusMz);
			float PminusMqu = (PminusMx*PminusMx) + (PminusMz*PminusMz);
			float Uqu = (wand.laengex*wand.laengex) + (wand.laengez*wand.laengez);
			float wurzel = (UmalPmM*UmalPmM) - (Uqu*(PminusMqu-(radius*radius)));
			if(wurzel == 0) {
				float s = -UmalPmM / Uqu;
				if(s>=0&&s<=1) kollisionswert = 1;
			} else if(wurzel > 0) {
				float s1 = (float) ((-UmalPmM + Math.sqrt(wurzel)) / Uqu);
				float s2 = (float) ((-UmalPmM - Math.sqrt(wurzel)) / Uqu);
				if(s1>=0&&s1<=1 || s2>=0&&s2<=1) kollisionswert = 1;
			}
			if(kollisionswert >= 0 ) return true;	
		}
		return false;
	}


}
