package naknak.mesh;

import net.java.games.jogl.GL;

/**
 * Reflexionseigenschaften eines Materials
 * 
 * @author Michael Erlmann
 *
 */
public class Material {
	public float lichtAmbient[] = {0.2f, 0.2f, 0.2f, 1.0f};
	public float lichtDiffuse[] = {0.8f, 0.8f, 0.8f, 1.0f};
	public float lichtSpecular[] = {0.0f, 0.0f, 0.0f, 1.0f};
	public float lichtEmission[] = {0.0f, 0.0f, 0.0f, 1.0f};
	
	public Material(float r, float g, float b) {
		lichtAmbient[0] = r;
		lichtAmbient[1] = g;
		lichtAmbient[2] = b;
		lichtDiffuse[0] = r;
		lichtDiffuse[1] = g;
		lichtDiffuse[2] = b;		
	}
	
	public Material() {}
	
	public void setAmbient(float r, float g, float b, float a) {
		lichtAmbient[0] = r;
		lichtAmbient[1] = g;
		lichtAmbient[2] = b;
		lichtAmbient[3] = a;
	}

	public void setDiffuse(float r, float g, float b, float a) {
		lichtDiffuse[0] = r;
		lichtDiffuse[1] = g;
		lichtDiffuse[2] = b;
		lichtDiffuse[3] = a;
	}

	public void setSpecular(float r, float g, float b, float a) {
		lichtSpecular[0] = r;
		lichtSpecular[1] = g;
		lichtSpecular[2] = b;
		lichtSpecular[3] = a;
	}

	public void setEmission(float r, float g, float b, float a) {
		lichtEmission[0] = r;
		lichtEmission[1] = g;
		lichtEmission[2] = b;
		lichtEmission[3] = a;
	}
	
	public void setFarbe(float r, float g, float b) {
		lichtAmbient[0] = r;
		lichtAmbient[1] = g;
		lichtAmbient[2] = b;
		lichtDiffuse[0] = r;
		lichtDiffuse[1] = g;
		lichtDiffuse[2] = b;
	}
	
	public void zeichne(GL gl) {
		gl.glMaterialfv(GL.GL_FRONT, GL.GL_AMBIENT, lichtAmbient);
		gl.glMaterialfv(GL.GL_FRONT, GL.GL_DIFFUSE, lichtDiffuse);
		gl.glMaterialfv(GL.GL_FRONT, GL.GL_SPECULAR, lichtSpecular);
		gl.glMaterialfv(GL.GL_FRONT, GL.GL_EMISSION, lichtEmission);
	}
}
