package naknak.mesh;

/**
 * Ein Vertex mit Normale
 * 
 * @author Michael Erlmann
 *
 */
public class Vertex {
	public float x;
	public float y;
	public float z;
	public float normaleX;
	public float normaleY;
	public float normaleZ;
	
	/**
	 * 
	 */
	public Vertex() {
		x = 0.0f;
		y = 0.0f;
		z = 0.0f;
		normaleX = 0.0f;
		normaleY = 0.0f;
		normaleZ = 0.0f;
	}

	/**
	 * Erzeugt ein Vertex
	 * 
	 * @param x X-Richtung des Vektors
	 * @param y Y-Richtung des Vektors
	 * @param z Z-Richtung des Vektors
	 */
	public Vertex(float x, float y, float z) {
		this.x = x;
		this.y = y;
		this.z = z;
		normaleX = 0.0f;
		normaleY = 0.0f;
		normaleZ = 0.0f;
	}
	
	/**
	 * Erzeugt ein Vertex mit Normalen
	 * 
	 * @param x
	 * @param y
	 * @param z
	 * @param normaleX
	 * @param normaleY
	 * @param normaleZ
	 */
	public Vertex(float x, float y, float z, float normaleX, float normaleY, float normaleZ) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.normaleX = normaleX;
		this.normaleY = normaleY;
		this.normaleZ = normaleZ;
	}
	
	/**
	 * Ueberprueft, ob dieser Vertex mit dem gegebenen den gleichen Raum einnimmt, unabhaengig von der Normalen
	 * 
	 * @param vertex Der Vertex, mit dem verglichen wird
	 * @return true, falls die x, y und z-werte uebereinstimmen
	 */
	public boolean equals(Vertex input) {
		if(input.x == x && input.y == y && input.z == z) return true;
		else return false;
	}
}
