package naknak.objekte;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;

/**
 * Datenhaltung und Zeichenoperation fuer Nebel
 * 
 * @author Michael Erlmann
 *
 */
public class Nebel {
	boolean aktiv = true; // ist der nebel aktiv
	float[] nebelFarbe = new float[4];
	float start, ende, dichte;
	
	public Nebel(float r, float g, float b, float start, float ende, float dichte) {
		nebelFarbe[0] = r;
		nebelFarbe[1] = g;
		nebelFarbe[2] = b;
		nebelFarbe[3] = 1.0f;
		this.start = start;
		this.ende = ende;
		this.dichte = dichte;
	}
	
	public void setAktiv(boolean aktiv) {
		this.aktiv = aktiv;
	}
	
	public void zeichne(GLDrawable gld) {
		GL gl = gld.getGL();
		if(aktiv) {
			gl.glEnable(GL.GL_FOG);
			gl.glFogfv(GL.GL_FOG_COLOR, nebelFarbe);
			gl.glFogf(GL.GL_FOG_START, start);
			gl.glFogf(GL.GL_FOG_END, ende);
			gl.glFogf(GL.GL_FOG_DENSITY, dichte);
			gl.glFogi(GL.GL_FOG_MODE, GL.GL_LINEAR);
			gl.glHint (GL.GL_FOG_HINT, GL.GL_NICEST);
		} else {
			gl.glDisable(GL.GL_FOG);
		}
	}
}
