package naknak.objekte.lichter;

import net.java.games.jogl.GL;

/**
 * Oberklasse fuer Licht
 * 
 * @author Michael Erlmann
 *
 */
public abstract class AbstraktesLicht {
	int lichtnummer;
	float lichtAmbient[] = { 0.0f, 0.0f, 0.0f, 1.0f };
	float lichtDiffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float lichtSpecular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float lichtPosition[] = { 0.0f, 0.0f, 0.0f, 0.0f };
	
	public void setAmbient(float r, float g, float b, float a) {
		lichtAmbient[0] = r;
		lichtAmbient[1] = g;
		lichtAmbient[2] = b;
		lichtAmbient[3] = a;
	}

	public void setDiffuse(float r, float g, float b, float a) {
		lichtDiffuse[0] = r;
		lichtDiffuse[1] = g;
		lichtDiffuse[2] = b;
		lichtDiffuse[3] = a;
	}

	public void setSpecular(float r, float g, float b, float a) {
		lichtSpecular[0] = r;
		lichtSpecular[1] = g;
		lichtSpecular[2] = b;
		lichtSpecular[3] = a;
	}
	
	public void setPosition(float x, float y, float z) {
		lichtPosition[0] = x;
		lichtPosition[1] = y;
		lichtPosition[2] = z;
	}
	
	public float[] getLichtPosition() {
		return lichtPosition;
	}
	
	abstract void zeichne(GL gl) ;
}
