package naknak.objekte.lichter;

import net.java.games.jogl.GL;

/**
 * Datenhaltung und Zeichenoperation fuer positionelles Licht
 * 
 * @author Michael Erlmann
 *
 */
public class PositionellesLicht extends AbstraktesLicht {
	float konstant = 1.0f;
	float linear = 0.0f;
	float quadratisch = 0.0f;
	
	public PositionellesLicht(int lichtnummer, float x, float y, float z) {
		this.lichtnummer = lichtnummer;
		lichtPosition[0] = x;
		lichtPosition[1] = y;
		lichtPosition[2] = z;
		lichtPosition[3] = 1.0f;
	}

	public void setLeuchtrichtung(float x, float y, float z) {
		lichtPosition[0] = x;
		lichtPosition[1] = y;
		lichtPosition[2] = z;
	}
	
	public void setAttenuation(float konstant, float linear, float quadratisch) {
		this.konstant = konstant;
		this.linear = linear;
		this.quadratisch = quadratisch;
	}
	
	public void zeichne(GL gl) {
		gl.glLightf(lichtnummer, GL.GL_CONSTANT_ATTENUATION, konstant);
		gl.glLightf(lichtnummer, GL.GL_LINEAR_ATTENUATION, linear);
		gl.glLightf(lichtnummer, GL.GL_QUADRATIC_ATTENUATION, quadratisch);
		gl.glLightfv(lichtnummer, GL.GL_POSITION, lichtPosition);
		gl.glLightfv(lichtnummer, GL.GL_AMBIENT, lichtAmbient);
		gl.glLightfv(lichtnummer, GL.GL_DIFFUSE, lichtDiffuse);
		gl.glLightfv(lichtnummer, GL.GL_SPECULAR, lichtSpecular);
	}
}
