package naknak.objekte.lichter;

import net.java.games.jogl.GL;

/**
 * Datenhaltung und Zeichenoperation fuer einen Scheinwerfer
 * 
 * @author Michael Erlmann
 *
 */
public class Scheinwerfer extends PositionellesLicht {
	float blick[] = new float[4];
	float cutOff;
	float exponent;
	
	public Scheinwerfer(int lichtnummer, float x, float y, float z, float blickX, float blickY, float blickZ, float cutOff, float exponent) {
		super(lichtnummer, x, y, z);
		blick[0] = blickX;
		blick[1] = blickY;
		blick[2] = blickZ;
		blick[3] = 0.0f;
		this.cutOff = cutOff;
		this.exponent = exponent;
	}
	
	public void setBlickrichtung(float blickX, float blickY, float blickZ) {
		blick[0] = blickX;
		blick[1] = blickY;
		blick[2] = blickZ;
	}
	
	public void setCutOff(float cutOff) {
		this.cutOff = cutOff;
	}
	
	public void setExponent(float exponent) {
		this.exponent = exponent;
	}
	
	public void zeichne(GL gl) {
		gl.glLightf(lichtnummer, GL.GL_CONSTANT_ATTENUATION, konstant);
		gl.glLightf(lichtnummer, GL.GL_LINEAR_ATTENUATION, linear);
		gl.glLightf(lichtnummer, GL.GL_QUADRATIC_ATTENUATION, quadratisch);
		gl.glLightf(lichtnummer, GL.GL_SPOT_CUTOFF, cutOff);
		gl.glLightf(lichtnummer, GL.GL_SPOT_EXPONENT, exponent);
		gl.glLightfv(lichtnummer, GL.GL_SPOT_DIRECTION, blick);
		gl.glLightfv(lichtnummer, GL.GL_POSITION, lichtPosition);
		gl.glLightfv(lichtnummer, GL.GL_AMBIENT, lichtAmbient);
		gl.glLightfv(lichtnummer, GL.GL_DIFFUSE, lichtDiffuse);
		gl.glLightfv(lichtnummer, GL.GL_SPECULAR, lichtSpecular);
	}
}
